//*****************************************
//  Arduino Unoとマイコン間でRS232C通信
//　　BME280センサ ＋ USBシリアル変換基板
//****************************************
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
// BME280のインスタンス生成
Adafruit_BME280 bme;
// 変数定義
float temp;
float pressure;
float humid;
// 初期化
void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  bool status;
  status = bme.begin(0x76);
  while (!status) {
    Serial.println("BME280 sensorが使えません");
    delay(1000);
  }
}
//***** メインループ *****
void loop() {
  // BME280センサからデータ読み出し
  temp=bme.readTemperature();
  pressure=bme.readPressure() / 100.0F;
  humid=bme.readHumidity(); 
  // データで送信
  Serial.print(pressure, 1);
  Serial.print(",");
  Serial.print(temp, 1);
  Serial.print(",");
  Serial.println(humid, 1);
  delay(5000);      // 5秒間隔
}
