from machine import I2C,Pin, UART
import bme280
import utime
#I2Cモジュールのピン指定でインスタンス生成
i2c = I2C(1, sda=Pin(18), scl=Pin(19),freq=100000)
#BME280のライブラリでインスタンス生成
#Manage PackageでBME280のライブラリの追加が必要
bme = bme280.BME280(i2c=i2c)
#UARTモジュールのインスタンス生成
#ピンはUART0(TX,RX)がGPIO 0/1(default)　12/13　16/17
#UART1(tx,RX)はGPIO 4/5　8/9(default)
#uart = UART(0, 9600)    #デフォルトのピン設定GPIO 0/1
#ピン指定をする場合の記述は下記
uart = UART(0, baudrate=9600, tx=Pin(12), rx=Pin(13))

#****　メインループ *****
while True:
    #センサのデータをコンソールに出力
    print(bme.values)
    #センサから3種のデータ取り出し
    #roundで少数桁指定して文字列に変換
    tmp = str(round(bme.read_compensated_data()[0]/100, 1))
    pre = str(round(bme.read_compensated_data()[1]/256000, 2))
    hum = str(round(bme.read_compensated_data()[2]/1024, 1))
    #JSON形式に変換
    pre = "{\"Pres\":"+pre
    tmp = ",\"Temp\":"+tmp
    hum = ",\"Humi\":"+hum +"}\r\n"
    #UARTで送信
    uart.write(pre+tmp+hum)
    utime.sleep(10)   #10sec Interval
    