/*********************************
* Bluetooth classic 例題
*  Arduino Uno R4  115.2kbps
*********************************/
#include <Adafruit_BME280.h>
#include <ST7032_asukiaaa.h>
#include <MsTimer2.h>
// インスタンス生成-
Adafruit_BME280 bme;            // BME280
ST7032_asukiaaa lcd;            // 液晶表示器
// 変数定義
float temp,pres,humi;
uint8_t Flag, Interval;
/***************************
* タイマ割り込み処理
***************************/
void TMR1(void){
  Flag = 1;
}
/********** 初期化 ***********/
void setup() {
  Serial.begin(115200);         // UART
  // タイマ設定
  MsTimer2::set(3000, TMR1);    // インターバルタイマ
  MsTimer2::start();
  Interval = 10;                // 30秒用
  // LCD初期化
  lcd.begin(16, 2);             // 8文字２行
  lcd.setContrast(30);
  // センサ初期化
  while(!bme.begin(0x76)){
    Serial.println("BME280 not avalable");
    delay(1000);
  }
  // RN42 初期設定
  Serial.print("Start Bluetooth");
  Serial.print("$$$");          // コマンドモード
  Serial.print("SF,1\r");       // 工場出荷に戻す
  Serial.print("SN,BT_IoT\r");  // 名称設定
  Serial.print("SA,4\r");       // 認証設定
  Serial.print("R,1\r");        // リブート
}
/***** メインループ **************/
void loop() {
  if(Flag == 1){                // フラグがオンの場合
    Flag = 0;
    Interval--;                 // 30秒カウンタ
    // BME280からデータ読み出し
    temp = bme.readTemperature();
    pres = bme.readPressure() / 100.0;
    humi = bme.readHumidity();
    // LCD表示
    lcd.setCursor(0, 0);      // 1行目
    lcd.print("T=");                    
    lcd.print(temp, 1);       // 温度
    lcd.print("C  H=");
    lcd.print(humi ,1);       // 湿度
    lcd.print("%");
    lcd.setCursor(0, 1);      // 2行目
    lcd.print("P=");
    lcd.print(pres, 1);       // 気圧
    lcd.print(" hPa");
  }
  //　30秒ごとのBluetooth送信
  if(Interval == 0){
    Interval = 10;            // 30秒設定
    // JSONフォーマットでBluetooth送信
    Serial.print("{\"Pres\":");
    Serial.print(pres, 1);
    Serial.print(",\"Temp\":");
    Serial.print(temp, 1);
    Serial.print(",\"Humi\":");
    Serial.print(humi, 1);
    Serial.println("}");
  }
}
