/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18877
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set D2 aliases
#define D2_TRIS                 TRISAbits.TRISA4
#define D2_LAT                  LATAbits.LATA4
#define D2_PORT                 PORTAbits.RA4
#define D2_WPU                  WPUAbits.WPUA4
#define D2_OD                   ODCONAbits.ODCA4
#define D2_ANS                  ANSELAbits.ANSA4
#define D2_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define D2_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define D2_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define D2_GetValue()           PORTAbits.RA4
#define D2_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define D2_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define D2_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define D2_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define D2_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define D2_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define D2_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define D2_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set D3 aliases
#define D3_TRIS                 TRISAbits.TRISA5
#define D3_LAT                  LATAbits.LATA5
#define D3_PORT                 PORTAbits.RA5
#define D3_WPU                  WPUAbits.WPUA5
#define D3_OD                   ODCONAbits.ODCA5
#define D3_ANS                  ANSELAbits.ANSA5
#define D3_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define D3_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define D3_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define D3_GetValue()           PORTAbits.RA5
#define D3_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define D3_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define D3_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define D3_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define D3_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define D3_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define D3_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define D3_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set D4 aliases
#define D4_TRIS                 TRISAbits.TRISA6
#define D4_LAT                  LATAbits.LATA6
#define D4_PORT                 PORTAbits.RA6
#define D4_WPU                  WPUAbits.WPUA6
#define D4_OD                   ODCONAbits.ODCA6
#define D4_ANS                  ANSELAbits.ANSA6
#define D4_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define D4_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define D4_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define D4_GetValue()           PORTAbits.RA6
#define D4_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define D4_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define D4_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define D4_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define D4_SetPushPull()        do { ODCONAbits.ODCA6 = 0; } while(0)
#define D4_SetOpenDrain()       do { ODCONAbits.ODCA6 = 1; } while(0)
#define D4_SetAnalogMode()      do { ANSELAbits.ANSA6 = 1; } while(0)
#define D4_SetDigitalMode()     do { ANSELAbits.ANSA6 = 0; } while(0)

// get/set D5 aliases
#define D5_TRIS                 TRISAbits.TRISA7
#define D5_LAT                  LATAbits.LATA7
#define D5_PORT                 PORTAbits.RA7
#define D5_WPU                  WPUAbits.WPUA7
#define D5_OD                   ODCONAbits.ODCA7
#define D5_ANS                  ANSELAbits.ANSA7
#define D5_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define D5_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define D5_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define D5_GetValue()           PORTAbits.RA7
#define D5_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define D5_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define D5_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define D5_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define D5_SetPushPull()        do { ODCONAbits.ODCA7 = 0; } while(0)
#define D5_SetOpenDrain()       do { ODCONAbits.ODCA7 = 1; } while(0)
#define D5_SetAnalogMode()      do { ANSELAbits.ANSA7 = 1; } while(0)
#define D5_SetDigitalMode()     do { ANSELAbits.ANSA7 = 0; } while(0)

// get/set S1 aliases
#define S1_TRIS                 TRISBbits.TRISB4
#define S1_LAT                  LATBbits.LATB4
#define S1_PORT                 PORTBbits.RB4
#define S1_WPU                  WPUBbits.WPUB4
#define S1_OD                   ODCONBbits.ODCB4
#define S1_ANS                  ANSELBbits.ANSB4
#define S1_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define S1_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define S1_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define S1_GetValue()           PORTBbits.RB4
#define S1_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define S1_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define S1_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define S1_SetPushPull()        do { ODCONBbits.ODCB4 = 0; } while(0)
#define S1_SetOpenDrain()       do { ODCONBbits.ODCB4 = 1; } while(0)
#define S1_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define S1_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set RC0 procedures
#define RC0_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define RC0_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define RC0_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define RC0_GetValue()              PORTCbits.RC0
#define RC0_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define RC0_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define RC0_SetPullup()             do { WPUCbits.WPUC0 = 1; } while(0)
#define RC0_ResetPullup()           do { WPUCbits.WPUC0 = 0; } while(0)
#define RC0_SetAnalogMode()         do { ANSELCbits.ANSC0 = 1; } while(0)
#define RC0_SetDigitalMode()        do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set RC1 procedures
#define RC1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define RC1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define RC1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define RC1_GetValue()              PORTCbits.RC1
#define RC1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define RC1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define RC1_SetPullup()             do { WPUCbits.WPUC1 = 1; } while(0)
#define RC1_ResetPullup()           do { WPUCbits.WPUC1 = 0; } while(0)
#define RC1_SetAnalogMode()         do { ANSELCbits.ANSC1 = 1; } while(0)
#define RC1_SetDigitalMode()        do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()              PORTCbits.RC4
#define RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()             do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()           do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode()         do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()        do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set S2 aliases
#define S2_TRIS                 TRISCbits.TRISC5
#define S2_LAT                  LATCbits.LATC5
#define S2_PORT                 PORTCbits.RC5
#define S2_WPU                  WPUCbits.WPUC5
#define S2_OD                   ODCONCbits.ODCC5
#define S2_ANS                  ANSELCbits.ANSC5
#define S2_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define S2_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define S2_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define S2_GetValue()           PORTCbits.RC5
#define S2_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define S2_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define S2_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define S2_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define S2_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define S2_SetAnalogMode()      do { ANSELCbits.ANSC5 = 1; } while(0)
#define S2_SetDigitalMode()     do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set RST aliases
#define RST_TRIS                 TRISDbits.TRISD2
#define RST_LAT                  LATDbits.LATD2
#define RST_PORT                 PORTDbits.RD2
#define RST_WPU                  WPUDbits.WPUD2
#define RST_OD                   ODCONDbits.ODCD2
#define RST_ANS                  ANSELDbits.ANSD2
#define RST_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define RST_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define RST_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define RST_GetValue()           PORTDbits.RD2
#define RST_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define RST_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)
#define RST_SetPullup()          do { WPUDbits.WPUD2 = 1; } while(0)
#define RST_ResetPullup()        do { WPUDbits.WPUD2 = 0; } while(0)
#define RST_SetPushPull()        do { ODCONDbits.ODCD2 = 0; } while(0)
#define RST_SetOpenDrain()       do { ODCONDbits.ODCD2 = 1; } while(0)
#define RST_SetAnalogMode()      do { ANSELDbits.ANSD2 = 1; } while(0)
#define RST_SetDigitalMode()     do { ANSELDbits.ANSD2 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/