//************************************
//　Arduinoでアナログ入力しLCD表示
//　　Analog_Sensor
//　　KXTC9-2050　　SB1602B
//***********************************
#include <Wire.h>                 // I2C用
#include <ST7032_asukiaaa.h>
// インスタンス生成
ST7032_asukiaaa lcd;              // 液晶表示器
// 変数宣言
int x, y, z, pot;
char Line1[17], Line2[17];

//***** 初期設定 *****
void setup() {
  // LCD初期化
  lcd.begin(16, 2);               // 16文字2行
  lcd.setContrast(40);            // コントラスト設定
  analogReference(EXTERNAL);      // ADCリファレンス設定 
}
//******* メインループ *******
void loop() {
  // 加速度センサ入力
  x = analogRead(A2) - 511;       // X軸入力
  y = analogRead(A1) - 511;       // Y軸入力
  z = analogRead(A0) - 511;       // Z軸入力
  pot = analogRead(A3);           // POT入力
  // 液晶表示器に編集し表示出力
  lcd.setCursor(0, 0);            // 1行目指定       
  sprintf(Line1, "X= %3d  Y= %3d  ",x, y);
  lcd.print(Line1);               // 表示実行
  lcd.setCursor(0, 1);            // 2行目指定
  sprintf(Line2, "Z= %3d  POT=%4d",z, pot);
  lcd.print(Line2);               // 表示実行

  delay(1000);                    // 1秒間隔
}
