/***********************************************
 *  Seeduino XIAOを使った例題
 * 　BME280の3種のデータをOLEDに表示
 **********************************************/
#include <Wire.h>
#include <SparkFunBME280.h> 
#include <Adafruit_SSD1306.h>
// インスタンス生成
Adafruit_SSD1306 display(128, 32, &Wire, -1);
BME280 sensor;
/***** 設定関数 ***********/
void setup(){
  Wire.begin();
  sensor.settings.I2CAddress = 0x76;    // BMEのI2Cアドレス指定
  sensor.beginI2C();                    // BMEの初期化
  pinMode(2, OUTPUT);                   // 目印LED
  pinMode(3, OUTPUT);
  // OLEDの電源電圧とI2Cアドレス設定
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); 
}
  /***** メインループ *******************/
void loop(){
  digitalWrite(2, LOW);
  digitalWrite(3, HIGH);            // 目印オン
  // OLED描画条件指定
  display.clearDisplay();           // 表示クリア
  display.setTextSize(1);           // 出力する文字の大きさ
  display.setTextColor(WHITE);      // 出力する文字の色  
  // センサデータOLED表示 
  display.setCursor(0, 0);          // 表示開始位置をホームにセット
  display.print("Press = ");        // 気圧の表示
  display.print(sensor.readFloatPressure() / 100.0, 1);
  display.println(" hPa");          // 気圧の単位表示
  display.setCursor(0, 11);         // 2行目指定
  display.print("Temp  = ");        // 温度の表示
  display.print(sensor.readTempC(), 2);
  display.println("  DegC");        // 温度の単位表示
  display.setCursor(0, 22);         // 3行目
  display.print("Humi  = ");        // 湿度の表示
  display.print(sensor.readFloatHumidity(), 2);
  display.println("  %RH");         // 湿度の単位表示
  display.display();                // 表示実行
  digitalWrite(3, LOW);             // 目印オフ
  delay(2000);                      // 2秒間隔
}
