/***********************************************
 *  Seeduino XIAOを使った例題
 * 　BME280の3種のデータをカラーOLEDに表示
 **********************************************/
#include <Wire.h>
#include <SparkFunBME280.h> 
#include <SPI.h>
#include <Adafruit_SSD1331.h>
// 画面色の定義
#define	BLACK     0x0000
#define	BLUE      0x001F
#define	RED       0xF800
#define	GREEN     0x07E0
#define CYAN      0x07FF
#define MAGENTA   0xF81F
#define YELLOW    0xFFE0
#define WHITE     0xFFFF
// インスタンス生成
Adafruit_SSD1331 display = Adafruit_SSD1331(&SPI, 0, 1, 2);
BME280 sensor;

//**** 初期設定 ******
void setup() {
  Wire.begin();
  sensor.settings.I2CAddress = 0x76;    // BMEのI2Cアドレス指定
  sensor.beginI2C();                    // BMEの初期化
  pinMode(3, OUTPUT);                   // 目印LED
  pinMode(6, OUTPUT);
  //OLEDの初期化
  display.begin();       
  display.fillScreen(BLACK);            // 全画面消去
  display.setRotation(3);               // 画面向きの指定
}
//**** メインループ *************
void loop() {
  digitalWrite(3, LOW);
  digitalWrite(6, HIGH);                // 目印オン
  // 画面消去と見出し表示
  display.fillScreen(BLACK);            // 全画面消去
  display.setCursor(0, 0);              // ホーム指定
  display.setTextColor(WHITE);          // 白
  display.setTextSize(1);               // 文字サイズ小
  display.println("Room Environment");  // 見出し表示 
  // センサデータOLED表示 
  display.setTextSize(2);               // 文字サイズ大
  display.setCursor(0, 12);             // 表示開始位置を指定                  
  display.setTextColor(GREEN);          // 緑
  display.print(sensor.readFloatPressure() / 100.0, 0);
  display.println(" hPa");              // 気圧の単位表示
  display.setTextColor(MAGENTA);        // マゼンタ
  display.print(sensor.readTempC(), 1);
  display.println(" Deg");              // 温度の単位表示
  display.setTextColor(CYAN);           // シアン
  display.print(sensor.readFloatHumidity(), 1);
  display.println(" %RH");              // 湿度の単位表示
  digitalWrite(6, LOW);                 // 目印オフ
  delay(2000);                          // 2秒間隔
}
