/*******************************
*　M5Core2＋拡張I/Oユニット
*　　RCサーボの制御
*******************************/
#include <M5Core2.h>
#include <M5GFX.h>
#include "M5_EXTIO2.h"
// インスタンス生成
M5_EXTIO2 extio;
M5GFX display;
M5Canvas canvas(&display);

// 変数定義
uint16_t width;

/**** 初期設定 ***********/
void setup() {
  M5.begin(true, false, true, true);  //LCD,SD,UART,I2C
  // グラフィック表示初期設定
  display.begin();
  canvas.setColorDepth(1);            // モノクロ
  canvas.setFont(&fonts::efontCN_14); // フォント指定
  canvas.createSprite(display.width(), display.height());
  canvas.setPaletteColor(1, GREEN);   // 色指定
  // 拡張I/O接続確認
  while(!extio.begin(&Wire, 21, 22, 0x45)){
    Serial.println("Extio Connect Error");
    delay(300);
  }
  Serial.println("Extio Connect!");
  // 拡張I/Oモード設定
  extio.setAllPinMode(SERVO_CTL_MODE);
  width = 540;        // パルス幅初期値
}

/***** メインループ ******/
void loop() {
  // 見出し表示とパルス幅表示
  canvas.setTextSize(2);
  canvas.setCursor(0, 0);
  canvas.printf("*** Servo Control ***"); // 見出し
  canvas.setCursor(10, 50);
  canvas.printf("CH:1,3,5  Width:%d", width);
  // バー描画
  canvas.drawRect(0, 120, 320, 50, 1);
  canvas.fillRect(0, 120, map(width, 540, 2400, 0, 320), 50, 1);
  canvas.pushSprite(0, 0);    // 表示実行
  //サーボ制御
  extio.setServoPulse(1, width);
  extio.setServoPulse(3, width);
  extio.setServoPulse(5, width);
  if(width == 540)
    delay(1000);
  // パルス幅アップ
  width += 20;                // 20usecごと
  if(width > 2400){           // パルス幅最大2400usec
    width = 540;              // 最小に戻す
    canvas.fillSprite(0);     // 画面消去
  }
  delay(100);                 // 100msec
}
