#**************************************
#  ラズパイPicoの制御プログラム
#　 PWMで、3台のRCサーボの制御
#**************************************
from machine import Pin, PWM
import time
#***** インスタンス生成*********
servo1 = PWM(Pin(7))
servo1.freq(50)
servo2 = PWM(Pin(8))
servo2.freq(50)
servo3 = PWM(Pin(9))
servo3.freq(50)
# 変数定義
Degree = 0
#***** メインループ *****************    
while True:
    #角度からデューティ設定を求める
    Duty = (int)((Degree/180.0)*(7864-1770)+1770)
    # 3台のRCサーボの制御
    servo1.duty_u16(Duty)
    servo2.duty_u16(Duty)
    servo3.duty_u16(Duty)
    # 0度に戻るときだけ1秒待つ
    if(Degree == 0):
        time.sleep(1)    
    # 時間間隔　5msec
    time.sleep(0.005)
    # 角度01度ずつアップ、180度で0に戻す
    Degree = Degree+0.1
    if(Degree > 180.0):
        Degree = 0
    