/**********************************************
 *  OLEDCu@@SSD1331p
 *  MSSP2iSP2jgp
 *********************************************/
#include "OLED_lib.h"
#include "ASCII12dot.h"		//ASCII 12x12dot
#include "font.h"
/********************************
* R}hAf[^o͊֐(SPI)
*********************************/
void spi_cmd(char cmnd){
    DC_SetLow();             // RS Command 
    CS_SetLow();				// CS Low
    SPI2_ExchangeByte(cmnd);
    DC_SetHigh();				// CD High
    CS_SetHigh();				// CS High
}
void spi_data(char data){
    DC_SetHigh();				// RS Data
    CS_SetLow();				// CS Low
    SPI2_ExchangeByte(data);
    CS_SetHigh();				// CS High
}

/****************************
* OLED֐  
*****************************/
void OLED_Init(void){
    RES_SetLow();
    __delay_ms(1);
    RES_SetHigh();
    __delay_ms(1000);
    SPI2_Open(SPI2_DEFAULT);
    spi_cmd(0xA4);          // Normal Display Mode
    spi_cmd(0xAF);          // Set Display On
    spi_cmd(0xA0);          // Set Color depth 
    spi_cmd(0b00100000);    // ォE֕\ 256F
    spi_cmd(0xB0);          // Powersave mode
    spi_cmd(0x0B);          // No:Disable
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(0);             // Start
    spi_cmd(95);            // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(0);             // Start
    spi_cmd(63);            // End
    // Set Contrast
    spi_cmd(0x81);          // Color A
    spi_cmd(0xFF);
    spi_cmd(0x82);          // Color B
    spi_cmd(0xFF);
    spi_cmd(0x83);          // Color C
    spi_cmd(0xFF);
}
/*********************************
 * SʎwFŏ
 *********************************/
void OLED_Clear(char color){
    uint16_t i;
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(0);             // Start
    spi_cmd(95);            // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(0);             // Start
    spi_cmd(63);            // End
    for(i=0; i<=(96*64); i++)
        spi_data(color);
}
/************************************
 * 1sNZ\֐
 * W(0,0)(95,63)
 ***********************************/
void OLED_Pixel(char Xpos, char Ypos, char color){
    // Set Window Frame
    spi_cmd(0x15);          // Column Window Set
    spi_cmd(Xpos);          // Start
    spi_cmd(Xpos);          // End
    spi_cmd(0x75);          // Row Window Set
    spi_cmd(Ypos);          // Start
    spi_cmd(Ypos);          // End
    spi_data(color);        // Write    
}
/*****************************************
*  ANK\֐ 6x9hbg
*  96/6=16/s@64/9=7s
*  (0, 0) - (11, 7)͈̔
******************************************/
void OLED_Char(char colum, char line, const char letter, char Color1, char Color2){
    char j, i, Mask;

    for(j=0; j<5; j++){                                     // 5hbg
        OLED_Pixel(colum*6+j, (line+1)*9-8, Color2);        // ŏ㗓
        Mask = 0x80;                                        // ʃrbg\
        for(i=0; i<8; i++){                                 // c1C\         
            if((Font[letter-0x20][j] & Mask) != 0)
                OLED_Pixel(colum*6+j, (line+1)*9-i, Color1);
            else
                OLED_Pixel(colum*6+j, (line+1)*9-i, Color2); //wiF
            Mask = Mask >> 1;
        }
    }
    for(j=5; j<6; j++){                                     // 3hbguN
        for(i=0; i<9; i++)
            OLED_Pixel(colum*6+j, (line+1)*9-i, Color2);      //wiF         
    }
}
/*****************************************
*  ASCII\֐ 12x12hbg
*  96/12=8/s@64/13=5s
*  (0, 0) - (7, 4)͈̔, FAwiF
******************************************/
void OLED_xChar(char colum, char line, char letter, char Color1, char Color2){
    char j, i, Mask;

    // ANK\ó@3oCg2C6JԂ
    for(j=0; j<6; j++){
        // 8hbgA̕\
        Mask = 0x80;
        for(i=0; i<8; i++){
            // PCڑO8hbg\
            if((ANKFont[letter][j*3] & Mask) != 0)
                OLED_Pixel(colum*12+i, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i, line*13+j*2+1, Color2); 	//wiF
            // 2Cڌ㔼8hbg\
            if((ANKFont[letter][j*3+2] & Mask) != 0)
                OLED_Pixel(colum*12+i+4, line*13+j*2+2, Color1);
            else
                OLED_Pixel(colum*12+i+4, line*13+j*2+2, Color2); 	//wiF
            Mask = Mask >> 1;
        }
        // 4hbg\
        Mask = 0x80;
        // 1Cڌ㔼4hbg\
        for(i=0; i<4; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i+8, line*13+j*2+1, Color1);
            else
                OLED_Pixel(colum*12+i+8, line*13+j*2+1, Color2);	 //wiF
            Mask = Mask >> 1;
        }
        // 2CڑO4hbg\
        for(i=4; i<8; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                OLED_Pixel(colum*12+i-4, line*13+j*2+2, Color1);
            else
                OLED_Pixel(colum*12+i-4, line*13+j*2+2, Color2); 	//wiF
            Mask = Mask >> 1;
        }							
    }
}
/******************************
*   12x12`֐
*   85sŎw
******************************/
void OLED_xStr(char colum, char line, const char *s, char Color1, char Color2)
{
    while (*s != 0){
        OLED_xChar(colum++, line, *s++, Color1, Color2);
        if(colum >= 8){
            line++;
            colum = 0;
            if(line >= 5)
                line = 0;
        }
    }
}
/******************************
*   6x9`֐
*   167sŎw
******************************/
void OLED_Str(char colum, char line, const char *s, char Color1, char Color2)
{
    while (*s != 0){
        OLED_Char(colum++, line, *s++, Color1, Color2);
        if(colum >= 16){
            line++;
            colum = 0;
            if(line >= 7)
                line = 0;
        }
    }
}
