/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F18857
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.36 and above
        MPLAB 	          :  MPLAB X 6.00	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RB2 procedures
#define RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define RB2_GetValue()              PORTBbits.RB2
#define RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define RB2_SetPullup()             do { WPUBbits.WPUB2 = 1; } while(0)
#define RB2_ResetPullup()           do { WPUBbits.WPUB2 = 0; } while(0)
#define RB2_SetAnalogMode()         do { ANSELBbits.ANSB2 = 1; } while(0)
#define RB2_SetDigitalMode()        do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set RB3 procedures
#define RB3_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define RB3_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define RB3_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define RB3_GetValue()              PORTBbits.RB3
#define RB3_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define RB3_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define RB3_SetPullup()             do { WPUBbits.WPUB3 = 1; } while(0)
#define RB3_ResetPullup()           do { WPUBbits.WPUB3 = 0; } while(0)
#define RB3_SetAnalogMode()         do { ANSELBbits.ANSB3 = 1; } while(0)
#define RB3_SetDigitalMode()        do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set CS aliases
#define CS_TRIS                 TRISBbits.TRISB5
#define CS_LAT                  LATBbits.LATB5
#define CS_PORT                 PORTBbits.RB5
#define CS_WPU                  WPUBbits.WPUB5
#define CS_OD                   ODCONBbits.ODCB5
#define CS_ANS                  ANSELBbits.ANSB5
#define CS_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define CS_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define CS_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define CS_GetValue()           PORTBbits.RB5
#define CS_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define CS_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define CS_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define CS_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define CS_SetPushPull()        do { ODCONBbits.ODCB5 = 0; } while(0)
#define CS_SetOpenDrain()       do { ODCONBbits.ODCB5 = 1; } while(0)
#define CS_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define CS_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()              PORTCbits.RC2
#define RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetPullup()             do { WPUCbits.WPUC2 = 1; } while(0)
#define RC2_ResetPullup()           do { WPUCbits.WPUC2 = 0; } while(0)
#define RC2_SetAnalogMode()         do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()        do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()              PORTCbits.RC4
#define RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()             do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()           do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode()         do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()        do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set RES aliases
#define RES_TRIS                 TRISCbits.TRISC6
#define RES_LAT                  LATCbits.LATC6
#define RES_PORT                 PORTCbits.RC6
#define RES_WPU                  WPUCbits.WPUC6
#define RES_OD                   ODCONCbits.ODCC6
#define RES_ANS                  ANSELCbits.ANSC6
#define RES_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RES_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RES_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RES_GetValue()           PORTCbits.RC6
#define RES_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RES_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RES_SetPullup()          do { WPUCbits.WPUC6 = 1; } while(0)
#define RES_ResetPullup()        do { WPUCbits.WPUC6 = 0; } while(0)
#define RES_SetPushPull()        do { ODCONCbits.ODCC6 = 0; } while(0)
#define RES_SetOpenDrain()       do { ODCONCbits.ODCC6 = 1; } while(0)
#define RES_SetAnalogMode()      do { ANSELCbits.ANSC6 = 1; } while(0)
#define RES_SetDigitalMode()     do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set DC aliases
#define DC_TRIS                 TRISCbits.TRISC7
#define DC_LAT                  LATCbits.LATC7
#define DC_PORT                 PORTCbits.RC7
#define DC_WPU                  WPUCbits.WPUC7
#define DC_OD                   ODCONCbits.ODCC7
#define DC_ANS                  ANSELCbits.ANSC7
#define DC_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define DC_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define DC_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define DC_GetValue()           PORTCbits.RC7
#define DC_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define DC_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define DC_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define DC_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define DC_SetPushPull()        do { ODCONCbits.ODCC7 = 0; } while(0)
#define DC_SetOpenDrain()       do { ODCONCbits.ODCC7 = 1; } while(0)
#define DC_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define DC_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/