#! usr/bin/enc python
# -*- coding: utf8 -*-
#************************************
# サーボ制御　　3台の制御
#　pigpioを使用　
#　0度から180度まで01秒でアップ
# sudo pigpiod でデーモン起動が必要
#************************************
import pigpio
import time
# インスタンス生成
pi = pigpio.pi()
# PWM周波数の設定
pi.set_PWM_frequency(18, 50)
pi.set_PWM_frequency(19, 50)
pi.set_PWM_frequency(27, 50)

#***************************
# 度からパルス幅に変換サブ関数
# 540usecから2400usecに変換
#**************************
def Conv(degree):
    return(540 + (2400 - 540)*degree/180.0)
# 初期値設定
degree = 0.0;

#*****　メインループ　*********************
while True:
    # 度からパルス幅に変換
    width = Conv(degree)
    # PWMパルス出力
    pi.set_servo_pulsewidth(18, width)
    pi.set_servo_pulsewidth(19, width)
    pi.set_servo_pulsewidth(27, width)
    # 遅延時間制御
    if degree == 0:
        time.sleep(2)
    else:
        time.sleep(0.03)
    # 度を更新
    degree = degree + 0.5
    # 180度を超えたら0度にする
    if degree > 180:
        degree = 0