/*****************************************
*  センサデータをAmbientに送信
*　30秒ごとに　温度、湿度、気圧を送信
******************************************/
#include <WiFi.h>
#include <Wire.h>
#include <SparkFunBME280.h>
#include "Ambient.h"
// インスタンス定義
BME280 sensor;
Ambient ambient;
WiFiClient client;
//定数定義
const char *ssid = "Buffalo-G-????";
const char *password = "7tb7ksh8????";
unsigned int channelId = ?????;
const char* writeKey = "b87afa2372?????";
/***** セットアップ  *******/
void setup(){
  Wire.begin();                               // I2C有効化
  Serial.begin(115200);
   // センサ初期化
  sensor.settings.I2CAddress = 0x76;
  sensor.beginI2C();                          // センサ初期化
  /**** ネットワークとの接続開始　APと接続 ***/
  WiFi.begin(ssid, password);                 // 雪像相手メッセージ
  // 接続完了まで繰り返す
  while (WiFi.status() != WL_CONNECTED) {     // 接続確認
      delay(500);
      Serial.print(".");
  }
  // 接続完了でIPアドレス表示
  Serial.println("");
  Serial.println("WiFi connected.");        // 接続完了メッセージ
  Serial.println("IP address: ");           // IPアドレスメッセージ
  Serial.println(WiFi.localIP());
  // Ambientと接続
  ambient.begin(channelId, writeKey, &client);
}
/*****  メインループ***********/
void loop() {
  float temp = sensor.readTempC();            // 温度データ取得
  float humi = sensor.readFloatHumidity();    // 湿度データ取得
  float pres = sensor.readFloatPressure()/100.0;
  // ambientデータセット
  ambient.set(1, temp);
  ambient.set(2, humi);
  ambient.set(3, pres);
  // ambient送信
  ambient.send();
  delay(30000);
}
