/*****************************************
*  センサデータをIFTTTでSpreadSheetに送信
*　1分ごとに　温度、湿度、気圧を送信
******************************************/
#include <WiFi.h>
#include <Wire.h>
#include <SparkFunBME280.h>
// インスタンス定義
BME280 sensor;
WiFiClient client;
//定数定義
const char *ssid = "Buffalo-G-????";
const char *password = "7tb7ksh8????";
char  t[7], h[7], p[7], body[60];
/***** セットアップ  *******/
void setup(){
  Wire.begin();                               // I2C有効化
  Serial.begin(115200);
   // センサ初期化
  sensor.settings.I2CAddress = 0x76;
  sensor.beginI2C();                          // センサ初期化
  /**** ネットワークとの接続開始　APと接続 ***/
  WiFi.begin(ssid, password);                 // 接続相手メッセージ
  // 接続完了まで繰り返す
  while (WiFi.status() != WL_CONNECTED) {     // 接続確認
      delay(500);
      Serial.print(".");
  }
  // 接続完了でIPアドレス表示
  Serial.println("");
  Serial.println("WiFi connected.");        // 接続完了メッセージ
  Serial.println("IP address: ");           // IPアドレスメッセージ
  Serial.println(WiFi.localIP());
}
/*****  メインループ***********/
void loop() {
  // IFTTTと接続
  if(client.connect("maker.ifttt.com", 80))
  {  
    Serial.println("Connect to IFTTT");
    float temp = sensor.readTempC();            // 温度データ取得
    float humi = sensor.readFloatHumidity();    // 湿度データ取得
    float pres = sensor.readFloatPressure()/100.0;
    // 送信データ作成
    dtostrf(temp, 3, 1, t);
    dtostrf(humi, 3, 1, h);
    dtostrf(pres, 5, 1, p);
    // POSTボディ生成
    sprintf(body, "{\"value1\":\"%s\",\"value2\":\"%s\",\"value3\":\"%s\"}\r\n", t, h, p);
    // POSTメッセージ設定
    String header1 = String("POST /trigger/Add_Data/with/key/dmmT_6fbmVbuF5bUT???? HTTP/1.1\r\n") +
                     String("Host: maker.ifttt.com\r\n") + 
                     String("Content-Type: application/json\r\n");
    String header2 = String("Content-Length: ") + "51" + String("\r\n\r\n");
    // POST送信
    Serial.println(header1 + header2 + body); 
    client.print(header1 + header2 + body);     // for debug
    client.stop();   
    // 1分ごと 
    delay(60000);
  }
}
