/*****************************************
*  イベントでIFTTT経由Email送信
*　スイッチでイベント発生
******************************************/
#include <WiFi.h>
#include <Wire.h>
// インスタンス定義
WiFiClient client;
//定数定義
const char *ssid = "Buffalo-G-????";
const char *password = "7tb7ksh8????";
char  body[60];
const int SW1 = 8;
const int SW2 = 9;
/***** セットアップ  *******/
void setup(){
  pinMode(SW1, INPUT_PULLUP);                 // プルアップ付入力
  pinMode(SW2, INPUT_PULLUP);                 // プルアップ付入力
  Wire.begin();                               // I2C有効化
  Serial.begin(115200);
  /**** ネットワークとの接続開始　APと接続 ***/
  WiFi.begin(ssid, password);                 // 接続相手メッセージd:\2出版関連文書\技術評論社\出版ZH（IoT事典）\Program\Sec5\Sec5-4-1\Arduino_Send_Email\Arduino_Send_Email.ino
  // 接続完了まで繰り返す
  while (WiFi.status() != WL_CONNECTED) {     // 接続確認
      delay(500);
      Serial.print(".");
  }
  // 接続完了でIPアドレス表示
  Serial.println("");
  Serial.println("WiFi connected.");        // 接続完了メッセージ
  Serial.println("IP address: ");           // IPアドレスメッセージ
  Serial.println(WiFi.localIP());
}
/*****  メインループ***********/
void loop() {
  // スイッチ押されたかの判定
  if((digitalRead(SW1) == LOW) || (digitalRead(SW2) == LOW)){
    // POSTボディ生成
    if(digitalRead(SW1) == LOW){      // SW1の場合
      sprintf(body, "{\"value1\":\"Switch #1 is pressed.\"}\r\n");
    }
    if(digitalRead(SW2) == LOW){      //SW2の場合
      sprintf(body, "{\"value1\":\"Switch #2 is pressed.\"}\r\n");    
    }  
    // IFTTTと接続
    if(client.connect("maker.ifttt.com", 80))
    {  
      Serial.println("Connect to IFTTT");
      // POSTメッセージ設定
      String header1 = String("POST /trigger/Send_Email/with/key/dmmT_6fbmVbuF5b?????? HTTP/1.1\r\n") +
                       String("Host: maker.ifttt.com\r\n") + 
                       String("Content-Type: application/json\r\n");
      String header2 = String("Content-Length: ") + "35" + String("\r\n\r\n");
      // POST送信
      Serial.println(header1 + header2 + body); 
      client.print(header1 + header2 + body);     // for debug
      client.stop();   
      // 5秒待ち 
      delay(5000);
    }
  }
}
