#*****************************************
#  Raspberry Pi Pico IFTTT経由メール送信
#  スイッチONでメール送信
#  
#*****************************************
from machine import Pin, Timer
import time
import network
import urequests
#Wi-FiのSSIDとパスワード設定
ssid = 'Buffalo-G-????'
password = '7tb7ksh8?????'
#POSTメッセージ定義
url = 'http://maker.ifttt.com/trigger/Send_Email/with/key/dmmT_6fbmVbuF5b?????'
header = {'Content-Type':'application/json'}
body = {'value1':"Message"}
#ピン設定
SW1 = machine.Pin(2, machine.Pin.IN, machine.Pin.PULL_UP)
SW2 = machine.Pin(3, machine.Pin.IN, machine.Pin.PULL_UP)
#***** 初期設定 ************************
#Wi-Fi接続開始
wlan = network.WLAN(network.STA_IF)
wlan.active(True)
wlan.connect(ssid, password)
# WiFi接続完了待ち　3秒間隔　10回繰り返す
max_wait = 10
while max_wait > 0:
    if wlan.status() < 0 or wlan.status() >= 3:
        break
    max_wait -= 1
    print('waiting for connection...')
    time.sleep(3)
# 接続失敗の場合　エラーメッセージ出力
if wlan.status() != 3:
    raise RuntimeError('network connection failed')
else:
    # 正常　IPアドレス出力
    print('Connected')
    status = wlan.ifconfig()
    print( 'ip = ' + status[0] )   

#******* メインループ ************************
while True:
    if SW1.value() == 0 or SW2.value() == 0:
        # Bodyにデータ追加
        if SW1.value() == 0:
            body['value1'] = "SW1 is pressed."
        else:
            body['value1'] = "SW2 is pressed."
         # IFTTTに送信
        try:
            res = urequests.post(url, json=body, headers=header)
            # Message 200 is OK
            print('HTTP State=', res.status_code)
        except Exception as e:
            print(e)
        res.close()
        # Wait 5sec
        time.sleep(5)
